Package icyllis.modernui.widget

# Class CoordinatorLayout.Behavior<V extends View>

java.lang.Object
icyllis.modernui.widget.CoordinatorLayout.Behavior<V>

Type Parameters:
  `V` - The View type that this Behavior operates on

Enclosing class:
  `CoordinatorLayout`

public abstract static class CoordinatorLayout.Behavior<V extends View> extends Object
Interaction behavior plugin for child views of `CoordinatorLayout`.

A Behavior implements one or more interactions that a user can take on a child view. These interactions may include drags, swipes, flings, or any other gestures.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Behavior()`
  Default constructor for instantiating Behaviors.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `blocksInteractionBelow(CoordinatorLayout parent, V child)`
  Determine whether interaction with views behind the given child in the child order should be blocked.
  `boolean`
  `getInsetDodgeRect(CoordinatorLayout parent, V child, Rect rect)`
  Called when a view is set to dodge view insets.
  `int`
  `getScrimColor(CoordinatorLayout parent, V child)`
  Supply a scrim color that will be painted behind the associated child view.
  `float`
  `getScrimOpacity(CoordinatorLayout parent, V child)`
  Determine the current opacity of the scrim behind a given child view
  `static Object`
  `getTag(View child)`
  Get the behavior-specific tag object with the given child view.
  `boolean`
  `layoutDependsOn(CoordinatorLayout parent, V child, View dependency)`
  Determine whether the supplied child view has another specific sibling view as a layout dependency.
  `void`
  `onAttachedToLayoutParams(CoordinatorLayout.LayoutParams params)`
  Called when the Behavior has been attached to a LayoutParams instance.
  `boolean`
  `onDependentViewChanged(CoordinatorLayout parent, V child, View dependency)`
  Respond to a change in a child's dependent view
  `void`
  `onDependentViewRemoved(CoordinatorLayout parent, V child, View dependency)`
  Respond to a child's dependent view being removed.
  `void`
  `onDetachedFromLayoutParams()`
  Called when the Behavior has been detached from its holding LayoutParams instance.
  `boolean`
  `onInterceptTouchEvent(CoordinatorLayout parent, V child, MotionEvent ev)`
  Respond to CoordinatorLayout touch events before they are dispatched to child views.
  `boolean`
  `onLayoutChild(CoordinatorLayout parent, V child, int layoutDirection)`
  Called when the parent CoordinatorLayout is about the lay out the given child view.
  `boolean`
  `onMeasureChild(CoordinatorLayout parent, V child, int parentWidthMeasureSpec, int widthUsed, int parentHeightMeasureSpec, int heightUsed)`
  Called when the parent CoordinatorLayout is about to measure the given child view.
  `boolean`
  `onNestedFling(CoordinatorLayout coordinatorLayout, V child, View target, float velocityX, float velocityY, boolean consumed)`
  Called when a nested scrolling child is starting a fling or an action that would be a fling.
  `boolean`
  `onNestedPreFling(CoordinatorLayout coordinatorLayout, V child, View target, float velocityX, float velocityY)`
  Called when a nested scrolling child is about to start a fling.
  `void`
  `onNestedPreScroll(CoordinatorLayout coordinatorLayout, V child, View target, int dx, int dy, int[] consumed, int type)`
  Called when a nested scroll in progress is about to update, before the target has consumed any of the scrolled distance.
  `void`
  `onNestedScroll(CoordinatorLayout coordinatorLayout, V child, View target, int dxConsumed, int dyConsumed, int dxUnconsumed, int dyUnconsumed, int type, int[] consumed)`
  Called when a nested scroll in progress has updated and the target has scrolled or attempted to scroll.
  `void`
  `onNestedScrollAccepted(CoordinatorLayout coordinatorLayout, V child, View directTargetChild, View target, int axes, int type)`
  Called when a nested scroll has been accepted by the CoordinatorLayout.
  `boolean`
  `onRequestChildRectangleOnScreen(CoordinatorLayout coordinatorLayout, V child, Rect rectangle, boolean immediate)`
  Called when a child of the view associated with this behavior wants a particular rectangle to be positioned onto the screen.
  `boolean`
  `onStartNestedScroll(CoordinatorLayout coordinatorLayout, V child, View directTargetChild, View target, int axes, int type)`
  Called when a descendant of the CoordinatorLayout attempts to initiate a nested scroll.
  `void`
  `onStopNestedScroll(CoordinatorLayout coordinatorLayout, V child, View target, int type)`
  Called when a nested scroll has ended.
  `boolean`
  `onTouchEvent(CoordinatorLayout parent, V child, MotionEvent ev)`
  Respond to CoordinatorLayout touch events after this Behavior has started `intercepting` them.
  `static void`
  `setTag(View child, Object tag)`
  Associate a Behavior-specific tag object with the given child view.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Behavior

    protected Behavior()
    Default constructor for instantiating Behaviors.

- ## Method Details

  - ### onAttachedToLayoutParams

    public void onAttachedToLayoutParams(@Nonnull CoordinatorLayout.LayoutParams params)
    Called when the Behavior has been attached to a LayoutParams instance.

    This will be called after the LayoutParams has been instantiated and can be modified.

    Parameters:
      `params` - the LayoutParams instance that this Behavior has been attached to

  - ### onDetachedFromLayoutParams

    public void onDetachedFromLayoutParams()
    Called when the Behavior has been detached from its holding LayoutParams instance.

    This will only be called if the Behavior has been explicitly removed from the LayoutParams instance via `CoordinatorLayout.LayoutParams.setBehavior(Behavior)`. It will not be called if the associated view is removed from the CoordinatorLayout or similar.

  - ### onInterceptTouchEvent

    public boolean onInterceptTouchEvent(@Nonnull CoordinatorLayout parent, @Nonnull V child, @Nonnull MotionEvent ev)
    Respond to CoordinatorLayout touch events before they are dispatched to child views.

    Behaviors can use this to monitor inbound touch events until one decides to intercept the rest of the event stream to take an action on its associated child view. This method will return false until it detects the proper intercept conditions, then return true once those conditions have occurred.

    Once a Behavior intercepts touch events, the rest of the event stream will be sent to the `onTouchEvent(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.MotionEvent)` method.

    This method will be called regardless of the visibility of the associated child of the behavior. If you only wish to handle touch events when the child is visible, you should add a check to `View.isShown()` on the given child.

    The default implementation of this method always returns false.

    Parameters:
      `parent` - the parent view currently receiving this touch event
      `child` - the child view associated with this Behavior
      `ev` - the MotionEvent describing the touch event being processed
    Returns:
      true if this Behavior would like to intercept and take over the event stream. The default always returns false.

  - ### onTouchEvent

    public boolean onTouchEvent(@Nonnull CoordinatorLayout parent, @Nonnull V child, @Nonnull MotionEvent ev)
    Respond to CoordinatorLayout touch events after this Behavior has started `intercepting` them.

    Behaviors may intercept touch events in order to help the CoordinatorLayout manipulate its child views. For example, a Behavior may allow a user to drag a UI pane open or closed. This method should perform actual mutations of view layout state.

    This method will be called regardless of the visibility of the associated child of the behavior. If you only wish to handle touch events when the child is visible, you should add a check to `View.isShown()` on the given child.

    Parameters:
      `parent` - the parent view currently receiving this touch event
      `child` - the child view associated with this Behavior
      `ev` - the MotionEvent describing the touch event being processed
    Returns:
      true if this Behavior handled this touch event and would like to continue receiving events in this stream. The default always returns false.

  - ### getScrimColor

    public int getScrimColor(@Nonnull CoordinatorLayout parent, @Nonnull V child)
    Supply a scrim color that will be painted behind the associated child view.

    A scrim may be used to indicate that the other elements beneath it are not currently interactive or actionable, drawing user focus and attention to the views above the scrim.

    The default implementation returns black.

    Parameters:
      `parent` - the parent view of the given child
      `child` - the child view above the scrim
    Returns:
      the desired scrim color in 0xRRGGBB format. The default return value is black.
    See Also:
      - `getScrimOpacity(CoordinatorLayout, View)`

  - ### getScrimOpacity

    public float getScrimOpacity(@Nonnull CoordinatorLayout parent, @Nonnull V child)
    Determine the current opacity of the scrim behind a given child view

    A scrim may be used to indicate that the other elements beneath it are not currently interactive or actionable, drawing user focus and attention to the views above the scrim.

    The default implementation returns 0.0f.

    Parameters:
      `parent` - the parent view of the given child
      `child` - the child view above the scrim
    Returns:
      the desired scrim opacity from 0.0f to 1.0f. The default return value is 0.0f.

  - ### blocksInteractionBelow

    public boolean blocksInteractionBelow(@Nonnull CoordinatorLayout parent, @Nonnull V child)
    Determine whether interaction with views behind the given child in the child order should be blocked.

    The default implementation returns true if `getScrimOpacity(CoordinatorLayout, View)` would return > 0.0f.

    Parameters:
      `parent` - the parent view of the given child
      `child` - the child view to test
    Returns:
      true if `getScrimOpacity(CoordinatorLayout, View)` would return > 0.0f.

  - ### layoutDependsOn

    public boolean layoutDependsOn(@Nonnull CoordinatorLayout parent, @Nonnull V child, @Nonnull View dependency)
    Determine whether the supplied child view has another specific sibling view as a layout dependency.

    This method will be called at least once in response to a layout request. If it returns true for a given child and dependency view pair, the parent CoordinatorLayout will:

    1. Always lay out this child after the dependent child is laid out, regardless of child order.
    2. Call `onDependentViewChanged(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View)` when the dependency view's layout or position changes.
    Parameters:
      `parent` - the parent view of the given child
      `child` - the child view to test
      `dependency` - the proposed dependency of child
    Returns:
      true if child's layout depends on the proposed dependency's layout, false otherwise
    See Also:
      - `onDependentViewChanged(CoordinatorLayout, View, View)`

  - ### onDependentViewChanged

    public boolean onDependentViewChanged(@Nonnull CoordinatorLayout parent, @Nonnull V child, @Nonnull View dependency)
    Respond to a change in a child's dependent view

    This method is called whenever a dependent view changes in size or position outside of the standard layout flow. A Behavior may use this method to appropriately update the child view in response.

    A view's dependency is determined by `layoutDependsOn(CoordinatorLayout, View, View)` or if `child` has set another view as it's anchor.

    Note that if a Behavior changes the layout of a child via this method, it should also be able to reconstruct the correct position in `onLayoutChild`. `onDependentViewChanged` will not be called during normal layout since the layout of each child view will always happen in dependency order.

    If the Behavior changes the child view's size or position, it should return true. The default implementation returns false.

    Parameters:
      `parent` - the parent view of the given child
      `child` - the child view to manipulate
      `dependency` - the dependent view that changed
    Returns:
      true if the Behavior changed the child view's size or position, false otherwise

  - ### onDependentViewRemoved

    public void onDependentViewRemoved(@Nonnull CoordinatorLayout parent, @Nonnull V child, @Nonnull View dependency)
    Respond to a child's dependent view being removed.

    This method is called after a dependent view has been removed from the parent. A Behavior may use this method to appropriately update the child view in response.

    A view's dependency is determined by `layoutDependsOn(CoordinatorLayout, View, View)` or if `child` has set another view as it's anchor.

    Parameters:
      `parent` - the parent view of the given child
      `child` - the child view to manipulate
      `dependency` - the dependent view that has been removed

  - ### onMeasureChild

    public boolean onMeasureChild(@Nonnull CoordinatorLayout parent, @Nonnull V child, int parentWidthMeasureSpec, int widthUsed, int parentHeightMeasureSpec, int heightUsed)
    Called when the parent CoordinatorLayout is about to measure the given child view.

    This method can be used to perform custom or modified measurement of a child view in place of the default child measurement behavior. The Behavior's implementation can delegate to the standard CoordinatorLayout measurement behavior by calling `parent.onMeasureChild`.

    Parameters:
      `parent` - the parent CoordinatorLayout
      `child` - the child to measure
      `parentWidthMeasureSpec` - the width requirements for this view
      `widthUsed` - extra space that has been used up by the parent horizontally (possibly by other children of the parent)
      `parentHeightMeasureSpec` - the height requirements for this view
      `heightUsed` - extra space that has been used up by the parent vertically (possibly by other children of the parent)
    Returns:
      true if the Behavior measured the child view, false if the CoordinatorLayout should perform its default measurement

  - ### onLayoutChild

    public boolean onLayoutChild(@Nonnull CoordinatorLayout parent, @Nonnull V child, int layoutDirection)
    Called when the parent CoordinatorLayout is about the lay out the given child view.

    This method can be used to perform custom or modified layout of a child view in place of the default child layout behavior. The Behavior's implementation can delegate to the standard CoordinatorLayout measurement behavior by calling `parent.onLayoutChild`.

    If a Behavior implements `onDependentViewChanged(CoordinatorLayout, View, View)` to change the position of a view in response to a dependent view changing, it should also implement `onLayoutChild` in such a way that respects those dependent views. `onLayoutChild` will always be called for a dependent view after its dependency has been laid out.

    Parameters:
      `parent` - the parent CoordinatorLayout
      `child` - child view to lay out
      `layoutDirection` - the resolved layout direction for the CoordinatorLayout, such as `View.LAYOUT_DIRECTION_LTR` or `View.LAYOUT_DIRECTION_RTL`.
    Returns:
      true if the Behavior performed layout of the child view, false to request default layout behavior

  - ### setTag

    public static void setTag(@Nonnull View child, @Nullable Object tag)
    Associate a Behavior-specific tag object with the given child view. This object will be stored with the child view's LayoutParams.
    Parameters:
      `child` - child view to set tag with
      `tag` - tag object to set

  - ### getTag

    @Nullable public static Object getTag(@Nonnull View child)
    Get the behavior-specific tag object with the given child view. This object is stored with the child view's LayoutParams.
    Parameters:
      `child` - child view to get tag with
    Returns:
      the previously stored tag object

  - ### onStartNestedScroll

    public boolean onStartNestedScroll(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View directTargetChild, @Nonnull View target, int axes, int type)
    Called when a descendant of the CoordinatorLayout attempts to initiate a nested scroll.

    Any Behavior associated with any direct child of the CoordinatorLayout may respond to this event and return true to indicate that the CoordinatorLayout should act as a nested scrolling parent for this scroll. Only Behaviors that return true from this method will receive subsequent nested scroll events.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `directTargetChild` - the child view of the CoordinatorLayout that either is or contains the target of the nested scroll operation
      `target` - the descendant view of the CoordinatorLayout initiating the nested scroll
      `axes` - the axes that this nested scroll applies to. See `View.SCROLL_AXIS_HORIZONTAL`, `View.SCROLL_AXIS_VERTICAL`
      `type` - the type of input which cause this scroll event
    Returns:
      true if the Behavior wishes to accept this nested scroll
    See Also:
      - `ViewParent.onStartNestedScroll(View, View, int, int)`

  - ### onNestedScrollAccepted

    public void onNestedScrollAccepted(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View directTargetChild, @Nonnull View target, int axes, int type)
    Called when a nested scroll has been accepted by the CoordinatorLayout.

    Any Behavior associated with any direct child of the CoordinatorLayout may elect to accept the nested scroll as part of `onStartNestedScroll(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View, icyllis.modernui.view.View, int, int)`. Each Behavior that returned true will receive subsequent nested scroll events for that nested scroll.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `directTargetChild` - the child view of the CoordinatorLayout that either is or contains the target of the nested scroll operation
      `target` - the descendant view of the CoordinatorLayout initiating the nested scroll
      `axes` - the axes that this nested scroll applies to. See `View.SCROLL_AXIS_HORIZONTAL`, `View.SCROLL_AXIS_VERTICAL`
      `type` - the type of input which cause this scroll event
    See Also:
      - `ViewParent.onNestedScrollAccepted(View, View, int, int)`

  - ### onStopNestedScroll

    public void onStopNestedScroll(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View target, int type)
    Called when a nested scroll has ended.

    Any Behavior associated with any direct child of the CoordinatorLayout may elect to accept the nested scroll as part of `onStartNestedScroll(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View, icyllis.modernui.view.View, int, int)`. Each Behavior that returned true will receive subsequent nested scroll events for that nested scroll.

    `onStopNestedScroll` marks the end of a single nested scroll event sequence. This is a good place to clean up any state related to the nested scroll.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `target` - the descendant view of the CoordinatorLayout that initiated the nested scroll
      `type` - the type of input which cause this scroll event
    See Also:
      - `ViewParent.onStopNestedScroll(View, int)`

  - ### onNestedScroll

    public void onNestedScroll(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View target, int dxConsumed, int dyConsumed, int dxUnconsumed, int dyUnconsumed, int type, @Nonnull int[] consumed)
    Called when a nested scroll in progress has updated and the target has scrolled or attempted to scroll.

    Any Behavior associated with the direct child of the CoordinatorLayout may elect to accept the nested scroll as part of `onStartNestedScroll(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View, icyllis.modernui.view.View, int, int)`. Each Behavior that returned true will receive subsequent nested scroll events for that nested scroll.

    `onNestedScroll` is called each time the nested scroll is updated by the nested scrolling child, with both consumed and unconsumed components of the scroll supplied in pixels. Each Behavior responding to the nested scroll will receive the same values.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `target` - the descendant view of the CoordinatorLayout performing the nested scroll
      `dxConsumed` - horizontal pixels consumed by the target's own scrolling operation
      `dyConsumed` - vertical pixels consumed by the target's own scrolling operation
      `dxUnconsumed` - horizontal pixels not consumed by the target's own scrolling operation, but requested by the user
      `dyUnconsumed` - vertical pixels not consumed by the target's own scrolling operation, but requested by the user
      `type` - the type of input which cause this scroll event
      `consumed` - output. Upon this method returning, should contain the scroll distances consumed by this Behavior
    See Also:
      - `ViewParent.onNestedScroll(View, int, int, int, int, int, int[])`

  - ### onNestedPreScroll

    public void onNestedPreScroll(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View target, int dx, int dy, @Nonnull int[] consumed, int type)
    Called when a nested scroll in progress is about to update, before the target has consumed any of the scrolled distance.

    Any Behavior associated with the direct child of the CoordinatorLayout may elect to accept the nested scroll as part of `onStartNestedScroll(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View, icyllis.modernui.view.View, int, int)`. Each Behavior that returned true will receive subsequent nested scroll events for that nested scroll.

    `onNestedPreScroll` is called each time the nested scroll is updated by the nested scrolling child, before the nested scrolling child has consumed the scroll distance itself. Each Behavior responding to the nested scroll will receive the same values. The CoordinatorLayout will report as consumed the maximum number of pixels in either direction that any Behavior responding to the nested scroll reported as consumed.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `target` - the descendant view of the CoordinatorLayout performing the nested scroll
      `dx` - the raw horizontal number of pixels that the user attempted to scroll
      `dy` - the raw vertical number of pixels that the user attempted to scroll
      `consumed` - out parameter. consumed[0] should be set to the distance of dx that was consumed, consumed[1] should be set to the distance of dy that was consumed
      `type` - the type of input which cause this scroll event
    See Also:
      - `ViewParent.onNestedPreScroll(View, int, int, int[], int)`

  - ### onNestedFling

    public boolean onNestedFling(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View target, float velocityX, float velocityY, boolean consumed)
    Called when a nested scrolling child is starting a fling or an action that would be a fling.

    Any Behavior associated with the direct child of the CoordinatorLayout may elect to accept the nested scroll as part of `onStartNestedScroll(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View, icyllis.modernui.view.View, int, int)`. Each Behavior that returned true will receive subsequent nested scroll events for that nested scroll.

    `onNestedFling` is called when the current nested scrolling child view detects the proper conditions for a fling. It reports if the child itself consumed the fling. If it did not, the child is expected to show some sort of overscroll indication. This method should return true if it consumes the fling, so that a child that did not itself take an action in response can choose not to show an overfling indication.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `target` - the descendant view of the CoordinatorLayout performing the nested scroll
      `velocityX` - horizontal velocity of the attempted fling
      `velocityY` - vertical velocity of the attempted fling
      `consumed` - true if the nested child view consumed the fling
    Returns:
      true if the Behavior consumed the fling
    See Also:
      - `ViewParent.onNestedFling(View, float, float, boolean)`

  - ### onNestedPreFling

    public boolean onNestedPreFling(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull View target, float velocityX, float velocityY)
    Called when a nested scrolling child is about to start a fling.

    Any Behavior associated with the direct child of the CoordinatorLayout may elect to accept the nested scroll as part of `onStartNestedScroll(icyllis.modernui.widget.CoordinatorLayout, V, icyllis.modernui.view.View, icyllis.modernui.view.View, int, int)`. Each Behavior that returned true will receive subsequent nested scroll events for that nested scroll.

    `onNestedPreFling` is called when the current nested scrolling child view detects the proper conditions for a fling, but it has not acted on it yet. A Behavior can return true to indicate that it consumed the fling. If at least one Behavior returns true, the fling should not be acted upon by the child.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `target` - the descendant view of the CoordinatorLayout performing the nested scroll
      `velocityX` - horizontal velocity of the attempted fling
      `velocityY` - vertical velocity of the attempted fling
    Returns:
      true if the Behavior consumed the fling
    See Also:
      - `ViewParent.onNestedPreFling(View, float, float)`

  - ### onRequestChildRectangleOnScreen

    public boolean onRequestChildRectangleOnScreen(@Nonnull CoordinatorLayout coordinatorLayout, @Nonnull V child, @Nonnull Rect rectangle, boolean immediate)
    Called when a child of the view associated with this behavior wants a particular rectangle to be positioned onto the screen.

    The contract for this method is the same as `ViewParent.requestChildRectangleOnScreen(View, Rect, boolean)`.

    Parameters:
      `coordinatorLayout` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `rectangle` - The rectangle which the child wishes to be on the screen in the child's coordinates
      `immediate` - true to forbid animated or delayed scrolling, false otherwise
    Returns:
      true if the Behavior handled the request
    See Also:
      - `ViewParent.requestChildRectangleOnScreen(View, Rect, boolean)`

  - ### getInsetDodgeRect

    public boolean getInsetDodgeRect(@Nonnull CoordinatorLayout parent, @Nonnull V child, @Nonnull Rect rect)
    Called when a view is set to dodge view insets.

    This method allows a behavior to update the rectangle that should be dodged. The rectangle should be in the parent's coordinate system and within the child's bounds. If not, a `IllegalArgumentException` is thrown.

    Parameters:
      `parent` - the CoordinatorLayout parent of the view this Behavior is associated with
      `child` - the child view of the CoordinatorLayout this Behavior is associated with
      `rect` - the rect to update with the dodge rectangle
    Returns:
      true the rect was updated, false if we should use the child's bounds